

# Community

## 198\. Decisions

Feature Branches

Feature Branches are easy to make. You do not have to be a committer to make one. Just request the name of your branch be added to JIRA up on the developer’s mailing list and a committer will add it for you. Thereafter you can file issues against your feature branch in Apache HBase JIRA. Your code you keep elsewhere — it should be public so it can be observed — and you can update dev mailing list on progress. When the feature is ready for commit, 3 +1s from committers will get your feature merged. See [HBase, mail # dev - Thoughts about large feature dev branches](http://search-hadoop.com/m/asM982C5FkS1)

How to set fix version in JIRA on issue resolve

Here is how [we agreed](http://search-hadoop.com/m/azemIi5RCJ1) to set versions in JIRA when we resolve an issue. If master is going to be 2.0.0, and branch-1 1.4.0 then:

*   Commit only to master: Mark with 2.0.0

*   Commit to branch-1 and master: Mark with 2.0.0, and 1.4.0

*   Commit to branch-1.3, branch-1, and master: Mark with 2.0.0, 1.4.0, and 1.3.x

*   Commit site fixes: no version

Policy on when to set a RESOLVED JIRA as CLOSED

We [agreed](http://search-hadoop.com/m/4cIKs1iwXMS1) that for issues that list multiple releases in their _Fix Version/s_ field, CLOSE the issue on the release of any of the versions listed; subsequent change to the issue must happen in a new JIRA.

Only transient state in ZooKeeper!

You should be able to kill the data in zookeeper and hbase should ride over it recreating the zk content as it goes. This is an old adage around these parts. We just made note of it now. We also are currently in violation of this basic tenet — replication at least keeps permanent state in zk — but we are working to undo this breaking of a golden rule.

## 199\. Community Roles

### 199.1\. Release Managers

Each maintained release branch has a release manager, who volunteers to coordinate new features and bug fixes are backported to that release. The release managers are [committers](https://hbase.apache.org/team-list.html). If you would like your feature or bug fix to be included in a given release, communicate with that release manager. If this list goes out of date or you can’t reach the listed person, reach out to someone else on the list.

> End-of-life releases are not included in this list.

| Release | Release Manager |
| --- | --- |
| 1.2 | Sean Busbey |
| 1.3 | Mikhail Antonov |
| 1.4 | Andrew Purtell |
| 2.0 | Michael Stack |
| 2.1 | Duo Zhang |

## 200\. Commit Message format

We [agreed](http://search-hadoop.com/m/Gwxwl10cFHa1) to the following Git commit message format:

```
HBASE-xxxxx <title>. (<contributor>)
```

If the person making the commit is the contributor, leave off the '(<contributor>)' element.

